package main

import "fmt"

func isLeap(y int) bool {
	return y%4 == 0 && (y%100 != 0 || y%400 == 0)
}

func daysFromEpoch(d, m, y int) (res int) {
	for i := 1970; i < y; i++ {
		res += 365
		if isLeap(i) {
			res++
		}
	}
	for i := 1; i < m; i++ {
		if i == 11 || i == 4 || i == 6 || i == 9 {
			res += 30
		} else if i == 2 {
			res += 28
			if isLeap(y) {
				res++
			}
		} else {
			res += 31
		}
	}
	res += d
	return
}

func main() {
	var d, m, y int
	fmt.Print("In che giorno sei nato (g m a)? ")
	fmt.Scan(&d, &m, &y)
	birthdate := daysFromEpoch(d, m, y)
	fmt.Println("Dal 1/1/1970 alla tua nascita sono passati", birthdate, "giorni")
	fmt.Print("Che giorno è oggi (g m a)? ")
	fmt.Scan(&d, &m, &y)
	now := daysFromEpoch(d, m, y)
	fmt.Println("Dal 1/1/1970 a oggi sono passati", now, "giorni")
	age := now - birthdate
	fmt.Println("Hai", age, "giorni")
	fmt.Print("Divisori di ", age, ": ")
	count := printAndCount(age)
	fmt.Println("Ci sono", count, "divisori")
}
